export const colorLegend = (selection, props) => {
  const   {colorScale, height, circleR, 
           spacing, textOff, BgWidth,
           onClick, selectedColorValue
          } = props
   
  const backgroundRect = selection.selectAll('rect')
  	.data([null]);
  const n = colorScale.domain().length;
  backgroundRect.enter().append('rect')
  	.merge(backgroundRect)
  		.attr('x', -circleR *2)
  		.attr('y', -circleR *2)
  		.attr('rx', circleR)
  		.attr('width', BgWidth)
  		.attr('height', spacing * n + circleR *2 )
  		.attr('fill', 'white')
  		.attr('opacity', 0.5)
  
	const groups = selection.selectAll('g')
  			.data(colorScale.domain());
  const groupEnter = groups
  	.enter().append('g')
  		.attr('class', 'tick');
  
	groupEnter.merge(groups)
      .attr('transform', 
              (d, i) => `translate(0, ${i * spacing})`)
  		.attr('opacity', d => 
            (!selectedColorValue || d === selectedColorValue)
           		? 1
            	: 0.2
           )
    	.on('click', d => onClick(
    		d === selectedColorValue
    			? null
    			: d
    	));	
  
	groups.exit()
  		.attr('r', 0)
      .remove();
  
  groupEnter.append('circle')
      	.attr('r', 0)
      .merge(groups.select('circle'))
        .attr('r', circleR)
        .attr('fill', colorScale);

  
  groupEnter.append('text')
		.merge(groups.select('text'))
  		.text(d => d)
  		.attr('dy', '0.32em')
  		.attr('x', textOff);
  	
};


